'''
Created on April 2011 for Pyweek
@author: Martin Villalba (aka akira44)
'''

import pygame
import os
import Stuff


class Caffeine():
    """Class for the caffeine counter"""
    
    def __init__(self):
        dir = os.path.abspath("data/coffee_level/board.png")
        self.fondo, self.rect = Stuff.load_image(dir)
        self.image = self.fondo.copy()
        self.rect.x=540
        self.rect.y=0
        
        self.frames = []
        # Load the images
        for i in range(0,5):
            file = os.path.abspath("data/coffee_level/level{0}.png".format(i))
            self.frames += [Stuff.load_image(file, -1)[0]]
        
        # I just need an extra rect
        self.iconrect = Stuff.load_image(file, -1)[1]
        dir = os.path.abspath('data/sounds/coffee.wav')
        self.sound = Stuff.load_sound(dir)

         
    def start(self, level):
        self.level = level
        self.prev_level = 999
        self.update()
        
    def set_level(self, level):
        self.prev_level = self.level
        self.level = level

    def update(self):
        subrect = self.rect.copy()
        subrect.x = 0
        self.image.blit(self.fondo, subrect)

        if(self.prev_level < self.level):
            self.sound.play()
            self.prev_level=self.level
            
        temprect =  self.iconrect.copy()       
        if(self.level>=100):
            icon = self.frames[4]
        elif(self.level <= 0):
            icon = self.frames[0]
        else:
            icon = self.frames[self.level / 20]
        temprect.x = 25
        temprect.y = 5
        #self.image.blit(icon,temprect)
        self.image.blit(icon,temprect)
        