'''
Created on April 2011 for Pyweek
@author: Martin Villalba (aka akira44)
'''

#import pygame
import random
#from collections import deque
import Stuff
import Tasks
import Globals
import pygame
import os

# Nota: 14 es aqui el numero teorico de acciones a realizar en la oficina
# tiene que ser un enumerado, no un int, pero no tengo internet
# 15 es "llamar a mantenimiento"
class Todo():
    """Class for the to-do list"""

    def __init__(self):
        self.remaining = []
        random.seed()
        file = os.path.abspath('data/board.png')
        self.fondo, self.rect = Stuff.load_image(file)
        self.image = self.fondo.copy()
        self.rect.x=120
        self.rect.y=0
        file = os.path.abspath('data/sounds/buzzer.wav')
        self.sound = Stuff.load_sound(file)
        
        # There must be a better way of doing this
        file = os.path.abspath('data/fix/icon.png')
        self.icon_fix, self.icon_fix_rect=Stuff.load_image(file,-1)
        file = os.path.abspath('data/watercooler/icon.png')
        self.icon_watercooler, self.icon_watercooler_rect=Stuff.load_image(file,-1)
        file = os.path.abspath('data/fax/icon.png')
        self.icon_fax, self.icon_fax_rect=Stuff.load_image(file,-1)
        
        file = os.path.abspath('data/telephone/icon.png')
        self.icon_telephone, self.icon_telephone_rect=Stuff.load_image(file,-1)
        file = os.path.abspath('data/photocopier/icon.png')
        self.icon_photocopier, self.icon_photocopier_rect=Stuff.load_image(file,-1)
        file = os.path.abspath('data/typewriter/icon.png')
        self.icon_typewriter, self.icon_typewriter_rect=Stuff.load_image(file,-1)

    # Nivel es la probabilidad de que una tarea falle
    # 10=falla una de cada 4 veces, 0=nunca falla (uniforme en [0,40])
    def start(self, cant, level, allowable):
        self.remaining = []
        self.dificulty = level
        tasks = Tasks.Tasks.get_all_tasks()
        for i in range(0, cant):
            newitem = tasks[random.randint(0, len(tasks)-1)]
            while(newitem not in allowable):
                newitem = tasks[random.randint(0, len(tasks)-1)]
            self.remaining.append(newitem)
        self.__update()

    def accomplish(self, task, coworker):
        ret = False
        if (self.remaining[0] == task):
            self.remaining = self.remaining[1:]
            if(task == Tasks.Tasks.FIX_THIS):
                self.current_broken.change_broken_status(False)
                self.current_broken = None
            else:
                if (random.randint(0,30) <= self.dificulty):
                    # Ooops, you broke the machine!
                    self.remaining = [Tasks.Tasks.FIX_THIS, task]+self.remaining
                    coworker.change_broken_status(True)
                    self.current_broken = coworker
                    self.sound.play()
                else:
                    coworker.play_sound()
                    ret = True
            self.__update()
        return ret

    def im_done(self):
        return len(self.remaining)==0

    def remaining_tasks(self):
        return self.remaining

    def __update(self):
        subrect = self.rect.copy()
        subrect.x = 0
        self.image.blit(self.fondo, subrect)
        if(len(self.remaining)>0):
            for i in range(0,3):
                if (len(self.remaining) > i):
                    if(self.remaining[i] == Tasks.Tasks.FIX_THIS):
                        icon = self.icon_fix
                        temprect = self.icon_fix_rect.copy()
                    elif(self.remaining[i] == Tasks.Tasks.WATER):
                        icon = self.icon_watercooler
                        temprect = self.icon_watercooler_rect.copy()
                    elif(self.remaining[i] == Tasks.Tasks.FAX):
                        icon = self.icon_fax
                        temprect = self.icon_fax_rect.copy()
                    elif(self.remaining[i] == Tasks.Tasks.TELEPHONE):
                        icon = self.icon_telephone
                        temprect = self.icon_telephone_rect.copy()
                    elif(self.remaining[i] == Tasks.Tasks.PHOTOCOPIER):
                        icon = self.icon_photocopier
                        temprect = self.icon_photocopier_rect.copy()
                    elif(self.remaining[i] == Tasks.Tasks.TYPEWRITER):
                        icon = self.icon_typewriter
                        temprect = self.icon_typewriter_rect.copy()


                    temprect.x = 120 + (60 * i)
                    temprect.y = 3
                    self.image.blit(icon, temprect)