'''
Created on April 2011 for Pyweek
@author: Martin Villalba (aka akira44)
'''

import pygame
import Stuff
import os

class Workday():
    """Class for the hour counter"""
    
    def __init__(self):
        file = os.path.abspath('data/workday/board.png')
        self.fondo, self.rect = Stuff.load_image(file)
        self.image = self.fondo.copy()
        self.rect.x=0
        self.rect.y=0
        
        # Load the number images
        self.numbers = []
        for i in range(0,10):
            file = file = os.path.abspath('data/workday/{0}.png'.format(i))
            self.numbers += [Stuff.load_image(file)[0]]
        
        # I just need an extra rect
        self.iconrect = Stuff.load_image(file)[1]
    
    def start(self, seconds):
        self.full_time = seconds
        self.seconds_left = seconds
        self.update()

    def pass_time(self):
        self.seconds_left -= 1
        self.update()
    
    def time_remaining(self):
        return self.seconds_left
        
    def update(self):
        subrect = self.rect.copy()
        subrect.x = 0
        self.image.blit(self.fondo, subrect)

        # Lets guess the current hour - 9 to 17
        remaining = self.full_time - self.seconds_left
        hour = 9 + (remaining / (self.full_time / 8))

        # Now, the minutes - this could easily be random...
        minutes = int((remaining % (self.full_time / 8))*(60.0/(self.full_time / 8)))

        # And now, we blit the hour
        hour1 = hour / 10
        hour2 = hour % 10
        minutes1 = (minutes / 10)%10
        minutes2 = minutes % 10
        
        temprect =  self.iconrect.copy()       
        temprect.x = 15
        temprect.y = 10
        self.image.blit(self.numbers[hour1],temprect)
        temprect.x += 20
        self.image.blit(self.numbers[hour2],temprect)
        temprect.x += 30
        self.image.blit(self.numbers[minutes1],temprect)
        temprect.x += 20
        self.image.blit(self.numbers[minutes2],temprect)
